<?php 
/*
Plugin Name: WP Spry Menu
Plugin URI: http://takien.com/files/wp-plugins/wp-spry-menu
Description: Automatically create spry dropdown menu for Wordpress Category
Author: takien
Email: imissuaja@yahoo.com
Version: 1.0.1
Author URI: http://takien.com
*/

/* WP Spry Menu */
/**
 * Create Spry Dropdown Menu of Wordpress categories.
 *
*/

if ( is_admin() ){ // admin actions
  add_action( 'admin_menu', 'spry_add_page' );
  add_action( 'admin_init', 'spry_register_settings' );
  add_filter('admin_head', 'wp_spry_menu_js');
} else {
  // non-admin enqueues, actions, and filters
}

function spry_add_page() {
    add_options_page('WP Spry Menu', 'WP Spry Menu', 8, 'wpspryoptions', 'wp_spry_options_page');
}

function spry_register_settings() { // whitelist options
  register_setting( 'wp_spry_option', 'direction' );
  register_setting( 'wp_spry_option', 'home_text' );
  register_setting( 'wp_spry_option', 'depth' );
  register_setting( 'wp_spry_option', 'exclude' );
  register_setting( 'wp_spry_option', 'orderby' );
  register_setting( 'wp_spry_option', 'hide_empty' );
  register_setting( 'wp_spry_option', 'child_of' );

  
  
}

add_filter('wp_head', 'wp_spry_menu_js');


if (get_option('direction') == verticalr) {
	$cssfile = '<link href="'. WP_PLUGIN_URL . '/wp_spry_menu/SpryAssets/SpryMenuBarVertical.css" type="text/css" rel="stylesheet" />';
	$classname = 'MenuBarVertical';
	}
elseif (get_option('direction') == verticall) {
	$cssfile = '<link href="'. WP_PLUGIN_URL . '/wp_spry_menu/SpryAssets/SpryMenuBarVerticall.css" type="text/css" rel="stylesheet" />';
	$classname = 'MenuBarVertical';
	}
else  {
	$cssfile = '<link href="'. WP_PLUGIN_URL . '/wp_spry_menu/SpryAssets/SpryMenuBarHorizontal.css" type="text/css" rel="stylesheet" />';
	$classname = 'MenuBarHorizontal';

	}
		
$js = '<script src="' . WP_PLUGIN_URL . '/wp_spry_menu/SpryAssets/SpryMenuBar.js" type="text/javascript"></script>';

function wp_spry_menu_js() {
	global $js, $cssfile;
	echo $js . $cssfile;
	return;
}
	


/* start main fuction */
	
function wp_spry_menu( $args = '' ) {
	global $classname;
	
	$defaults = array(
		'show_option_all' => '',
		'orderby' => get_option('orderby'),
		'order' => 'ASC',
		'show_last_update' => 0,
		'sort_column' => 'name',
		'style' => 'list',
		'show_count' => 0,
		'title_li' => '',
		'hide_empty' => get_option('hide_empty'),
		'use_desc_for_title' => 1,
		'child_of' => get_option('child_of'),
		'feed' => '',
		'feed_type' => '',
		'feed_image' => '',
		'exclude' => get_option('exclude'),
		'current_category' => 0,
		'hierarchical' => true,
		'title_li' => __( '' ),
		'echo' => 1,
		'depth' => get_option('depth'),
	);


	$r = wp_parse_args( $args, $defaults );

	extract( $r );

	$categories = get_categories( $r );

	$output = '';


	if ( empty( $categories ) ) {
		if ( 'list' == $style )
			$output .= 'The category you selected have no child category, please select another.';
		else
			$output .= __( "No categories" );
	} else {
		global $wp_query;

		if ( empty( $r['current_category'] ) && is_category() )
			$r['current_category'] = $wp_query->get_queried_object_id();

	
		$output .= walk_category_tree( $categories, $depth, $r );
				
	

		
		if (get_option('home_text') !== '')
		$home = '<li class="cat-item"><a href="' . get_settings('home') . '" title="'. get_option('home_text') .'">'. get_option('home_text'). '</a></li>';
		else 
		$home = '';

	}
	


	
	$output = apply_filters( 'wp_spry_menu', $output );
	$output = '<ul id="wp_spry_menu" class="'.$classname.'">' .$home . $output . '</ul>
	
<script type="text/javascript">
<!--
var wp_spry_menu = new Spry.Widget.MenuBar("wp_spry_menu");
//-->
</script>
';
	if ( $echo )
		echo $output;
	else
		return $output;
	
}

function dropdown_child_of( $args = '' ) {
	$defaults = array(
		'default_child_of' => get_option('child_of'),
		'orderby' => 'ID', 'order' => 'ASC',
		'show_last_update' => 0, 'show_count' => 0,
		'hide_empty' => get_option('hide_empty'),
		'child_of' => 0,
		'exclude' => get_option('exclude'),
		'echo' => 1,
		'selected' => 0, 'hierarchical' => 1,
		'name' => 'child_of',
		'depth' => 0
	);


	$r = wp_parse_args( $args, $defaults );
	extract( $r );


	$categories = get_categories( $r );

	$output = '';
	if ( ! empty( $categories ) ) {
		$output = '<select name="'.$name.'">
		<option value="" '.((get_option('child_of') == '')?'selected="selected"':'').'>None</option>';
		   
		$output .= ((get_option('child_of') !== '')?'<option value="'.get_option('child_of').'" selected="selected">'.get_cat_name( $default_child_of ).'</option>':'');

		$output .= walk_category_dropdown_tree( $categories, $depth, $r );
		$output .= '</select>';
	}

	$output = apply_filters( 'wp_dropdown_cats', $output );

	if ( $echo )
		echo $output;

	return $output;
}
	
	
	

// option page on admin menu

function wp_spry_options_page() {
?>
<div class="wrap">
<h2>WP Spry Menu</h2>

<table width="100%">
<tr><td colspan="3">
<?php if (get_option('direction') == horizontal) {
wp_spry_menu();
} ?>
</td></tr>
<tr><td width="50%" valign="top">
<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>
<?php settings_fields( 'wp_spry_option' ); ?>


<table class="form-table">

<tr valign="top">
<th scope="row">Direction</th>
<td>
<select name="direction">

<option <?php if (get_option('direction') == verticalr) echo 'selected="selected"' ?> 
value="verticalr">Vertical Drop Right</option>

<option <?php if (get_option('direction') == verticall) echo 'selected="selected"' ?> 
value="verticall">Vertical Drop Left</option>

<option <?php if (get_option('direction') == horizontal) echo 'selected="selected"' ?>
value="horizontal">Horizontal</option>
</select>
</td>
</tr>
 
<tr valign="top">
<th scope="row">Home text</th>
<td><input type="text" name="home_text" value="<?php echo get_option('home_text'); ?>" /><br />
</td>
</tr>

<tr valign="top">
<th scope="row">Depth</th>
<td><input type="text" name="depth" value="<?php echo get_option('depth'); ?>" /></td>
</tr>

<tr valign="top">
<th scope="row">Exclude</th>
<td><input type="text" name="exclude" value="<?php echo get_option('exclude'); ?>" /></td>
</tr>

<tr valign="top">
<th scope="row">Order by</th>
<td>
<select name="orderby">
<option <?php if (get_option('orderby') == 'name') echo 'selected="selected"' ?> 
value="name">Name</option>

<option <?php if (get_option('orderby') == 'ID') echo 'selected="selected"' ?> 
value="ID">ID</option>
</select>

</td>
</tr>

<tr valign="top">
<th scope="row">Hide Empty</th>
<td>
<select name="hide_empty">
<option <?php if (get_option('hide_empty') == 0) echo 'selected="selected"' ?> 
value="0">No</option>

<option <?php if (get_option('hide_empty') == 1) echo 'selected="selected"' ?> 
value="1">Yes</option>
</select>

</td>
</tr>

<tr valign="top">
<th scope="row">Child Of</th>
<td>
   <?php dropdown_child_of('exclude='.get_option('exclude').''); ?>
</td>
</tr>

</table>
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="direction,some_other_option,option_etc" />

<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>

</form>
</td>
<td width="25%" valign="top">

<?php if (get_option('direction') == verticalr) {
wp_spry_menu();
} ?>

</td>
<td width="25%" valign="top">
<?php if (get_option('direction') == verticall) {
wp_spry_menu();
} ?>
</td>
</tr></table>
<br />
<h3>Legend</h3>
<small><strong>Home text</strong>: Text to displaying Home link, leave blank for no Home link</small>
<br />

<small><strong>Vertical Drop Left:</strong> Vertical menu, sub menu should drop to the left. <br />
<strong>Vertical Drop Right:</strong> Vertical menu, sub menu should drop to the right. <br />
<strong>Horizontal:</strong> Horizontal menu.<br>
<strong>Depth: </strong>Depth of child category want to display<br>
<strong>Exclude: </strong>Exclude some category, separated by comma<br>
<strong>Order by:</strong> Category listing should order by name or ID<br>
<strong>Hide empty: </strong>Chose yes will display an empty category too<br>
<strong>Child of: </strong>Menu will only display the child of selected category.</small>

<h3>Installation</h3>
<p>
Paste the following code to your tempate where you want to place dropdown menu.</p>

<textarea style="width:350px; height:50px; border:1px solid #ccc" cols="20" rows="5">
<?php echo "<?php if ( function_exists('wp_spry_menu') )
wp_spry_menu();?>" ?></textarea>

</div>
<?php
}
?>